<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.ruoyi.system.mapper.ExplainDocumentMapper">
    
    <resultMap type="ExplainDocument" id="ExplainDocumentResult">
        <result property="explainId"    column="explain_id"    />
        <result property="explainTitle"    column="explain_title"    />
        <result property="explainType"    column="explain_type"    />
        <result property="explainContent"    column="explain_content"    />
        <result property="status"    column="status"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectExplainDocumentVo">
        select explain_id, explain_title, explain_type, explain_content, status, create_by, create_time, update_by, update_time, remark from explain_document
    </sql>

    <select id="selectExplainDocumentList" parameterType="ExplainDocument" resultMap="ExplainDocumentResult">
        <include refid="selectExplainDocumentVo"/>
        <where>  
            <if test="explainTitle != null  and explainTitle != ''"> and explain_title = #{explainTitle}</if>
            <if test="explainType != null  and explainType != ''"> and explain_type = #{explainType}</if>
            <if test="explainContent != null  and explainContent != ''"> and explain_content = #{explainContent}</if>
            <if test="status != null  and status != ''"> and status = #{status}</if>
        </where>
        order by create_time
    </select>
    
    <select id="selectExplainDocumentByExplainId" parameterType="Integer" resultMap="ExplainDocumentResult">
        <include refid="selectExplainDocumentVo"/>
        where explain_id = #{explainId}
    </select>
        
    <insert id="insertExplainDocument" parameterType="ExplainDocument" useGeneratedKeys="true" keyProperty="explainId">
        insert into explain_document
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="explainTitle != null and explainTitle != ''">explain_title,</if>
            <if test="explainType != null and explainType != ''">explain_type,</if>
            <if test="explainContent != null">explain_content,</if>
            <if test="status != null">status,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="explainTitle != null and explainTitle != ''">#{explainTitle},</if>
            <if test="explainType != null and explainType != ''">#{explainType},</if>
            <if test="explainContent != null">#{explainContent},</if>
            <if test="status != null">#{status},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
         </trim>
    </insert>

    <update id="updateExplainDocument" parameterType="ExplainDocument">
        update explain_document
        <trim prefix="SET" suffixOverrides=",">
            <if test="explainTitle != null and explainTitle != ''">explain_title = #{explainTitle},</if>
            <if test="explainType != null and explainType != ''">explain_type = #{explainType},</if>
            <if test="explainContent != null">explain_content = #{explainContent},</if>
            <if test="status != null">status = #{status},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where explain_id = #{explainId}
    </update>

    <delete id="deleteExplainDocumentByExplainId" parameterType="Integer">
        delete from explain_document where explain_id = #{explainId}
    </delete>

    <delete id="deleteExplainDocumentByExplainIds" parameterType="String">
        delete from explain_document where explain_id in 
        <foreach item="explainId" collection="array" open="(" separator="," close=")">
            #{explainId}
        </foreach>
    </delete>
</mapper>